bwreg-webapp/src/main/java/edu/kit/scc/webreg/bean/admin/group/AddLocalGroupBean.java
/*******************************************************************************
 * Copyright (c) 2014 Michael Simon.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the GNU Public License v3.0
 * which accompanies this distribution, and is available at
 * http://www.gnu.org/licenses/gpl.html
 * 
 * Contributors:
 *     Michael Simon - initial
 ******************************************************************************/
package edu.kit.scc.webreg.bean.admin.group;

import java.io.Serializable;

import jakarta.annotation.PostConstruct;
import jakarta.enterprise.context.RequestScoped;
import jakarta.inject.Inject;
import jakarta.inject.Named;

import edu.kit.scc.webreg.entity.LocalGroupEntity;
import edu.kit.scc.webreg.service.LocalGroupService;
import edu.kit.scc.webreg.util.ViewIds;

@Named("addLocalGroupBean")
@RequestScoped
public class AddLocalGroupBean implements Serializable {

	private static final long serialVersionUID = 1L;

	@Inject
	private LocalGroupService service;
	
	private LocalGroupEntity entity;
	
	@PostConstruct
	public void init() {
		entity = service.createNew();
	}
	
	public String save() {
		service.save(entity);
		return ViewIds.LIST_LOCAL_GROUPS + "?faces-redirect=true";
	}

	public String cancel() {
		return ViewIds.LIST_LOCAL_GROUPS + "?faces-redirect=true";
	}

	public LocalGroupEntity getEntity() {
		return entity;
	}

	public void setEntity(LocalGroupEntity entity) {
		this.entity = entity;
	}
}

bwreg-webapp/src/main/java/edu/kit/scc/webreg/bean/admin/group/ListGroupBean.java
/*******************************************************************************
 * Copyright (c) 2014 Michael Simon.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the GNU Public License v3.0
 * which accompanies this distribution, and is available at
 * http://www.gnu.org/licenses/gpl.html
 * 
 * Contributors:
 *     Michael Simon - initial
 ******************************************************************************/
package edu.kit.scc.webreg.bean.admin.group;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.HashSet;
import java.util.List;

import jakarta.faces.event.ComponentSystemEvent;
import jakarta.faces.view.ViewScoped;
import jakarta.inject.Inject;
import jakarta.inject.Named;

import org.primefaces.model.LazyDataModel;
import org.slf4j.Logger;

import edu.kit.scc.webreg.dao.ops.PaginateBy;
import edu.kit.scc.webreg.dao.ops.RqlExpressions;
import edu.kit.scc.webreg.dao.ops.SortBy;
import edu.kit.scc.webreg.entity.EventType;
import edu.kit.scc.webreg.entity.GroupEntity;
import edu.kit.scc.webreg.entity.HomeOrgGroupEntity;
import edu.kit.scc.webreg.entity.ServiceBasedGroupEntity;
import edu.kit.scc.webreg.entity.ServiceEntity;
import edu.kit.scc.webreg.entity.ServiceEntity_;
import edu.kit.scc.webreg.entity.ServiceGroupFlagEntity;
import edu.kit.scc.webreg.entity.ServiceGroupStatus;
import edu.kit.scc.webreg.event.EventSubmitter;
import edu.kit.scc.webreg.event.MultipleGroupEvent;
import edu.kit.scc.webreg.event.exc.EventSubmitException;
import edu.kit.scc.webreg.model.GenericLazyDataModelImpl;
import edu.kit.scc.webreg.service.GroupService;
import edu.kit.scc.webreg.service.ServiceGroupFlagService;
import edu.kit.scc.webreg.service.ServiceService;

@Named
@ViewScoped
public class ListGroupBean implements Serializable {

	private static final long serialVersionUID = 1L;

	@Inject
	private Logger logger;

	@Inject
	private GroupService service;

	@Inject
	private ServiceService serviceService;

	@Inject
	private ServiceGroupFlagService groupFlagService;

	@Inject
	private EventSubmitter eventSubmitter;

	private LazyDataModel<GroupEntity> list;
	private Integer sizePerMessage = 50;
	private List<ServiceEntity> serviceList;
	private ServiceEntity pickedService;
	
	public void preRenderView(ComponentSystemEvent ev) {
	}

	public LazyDataModel<GroupEntity> getGroupEntityList() {
		if (list == null) {
			list = new GenericLazyDataModelImpl<GroupEntity, GroupService>(service);
		}
		return list;
	}

	public void addAllGroupFlags() {
		List<GroupEntity> groupList = service.findAll();

		for (GroupEntity group : groupList) {
			if (group instanceof HomeOrgGroupEntity) {
				ServiceBasedGroupEntity serviceBasedGroup = (HomeOrgGroupEntity) group;

				groupFlagService.createFlagIfMissing(serviceBasedGroup, pickedService);
			}
		}
	}

	public void fireDirtyGroupChangeEvent() {
		List<ServiceGroupFlagEntity> groupFlagList = groupFlagService.findByStatus(ServiceGroupStatus.DIRTY);
		groupFlagList.addAll(groupFlagService.findByStatus(ServiceGroupStatus.TO_DELETE));

		HashSet<GroupEntity> dirtyGroupSet = new HashSet<GroupEntity>();
		for (ServiceGroupFlagEntity gf : groupFlagList)
			dirtyGroupSet.add(gf.getGroup());

		List<HashSet<GroupEntity>> chunkList = new ArrayList<>();
		HashSet<GroupEntity> groups = null;
		int i = 0;
		for (GroupEntity group : dirtyGroupSet) {
			if ((i % sizePerMessage) == 0) {
				groups = new HashSet<GroupEntity>();
				chunkList.add(groups);
			}
			groups.add(group);
			i++;
		}

		for (HashSet<GroupEntity> groupSet : chunkList) {
			MultipleGroupEvent mge = new MultipleGroupEvent(groupSet);
			try {
				eventSubmitter.submit(mge, EventType.GROUP_UPDATE, "master-admin");
			} catch (EventSubmitException e) {
				logger.warn("Exeption", e);
			}
		}
	}

	public Integer getSizePerMessage() {
		return sizePerMessage;
	}

	public void setSizePerMessage(Integer sizePerMessage) {
		this.sizePerMessage = sizePerMessage;
	}

	public List<ServiceEntity> getServiceList() {
		if (serviceList == null) {
			serviceList = serviceService.findAll(PaginateBy.unlimited(), SortBy.ascendingBy("name"),
					RqlExpressions.equal(ServiceEntity_.groupCapable, true));
		}
		return serviceList;
	}

	public ServiceEntity getPickedService() {
		return pickedService;
	}

	public void setPickedService(ServiceEntity pickedService) {
		this.pickedService = pickedService;
	}
}

bwreg-webapp/src/main/java/edu/kit/scc/webreg/bean/admin/group/ListHomeOrgGroupBean.java
/*******************************************************************************
 * Copyright (c) 2014 Michael Simon.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the GNU Public License v3.0
 * which accompanies this distribution, and is available at
 * http://www.gnu.org/licenses/gpl.html
 * 
 * Contributors:
 *     Michael Simon - initial
 ******************************************************************************/
package edu.kit.scc.webreg.bean.admin.group;

import java.io.Serializable;

import jakarta.faces.event.ComponentSystemEvent;
import jakarta.faces.view.ViewScoped;
import jakarta.inject.Inject;
import jakarta.inject.Named;

import org.primefaces.model.LazyDataModel;

import edu.kit.scc.webreg.entity.HomeOrgGroupEntity;
import edu.kit.scc.webreg.model.GenericLazyDataModelImpl;
import edu.kit.scc.webreg.service.HomeOrgGroupService;

@Named
@ViewScoped
public class ListHomeOrgGroupBean implements Serializable {

	private static final long serialVersionUID = 1L;

	private LazyDataModel<HomeOrgGroupEntity> list;
    
    @Inject
    private HomeOrgGroupService service;

	public void preRenderView(ComponentSystemEvent ev) {
		if (list == null) {
			list = new GenericLazyDataModelImpl<HomeOrgGroupEntity, HomeOrgGroupService>(service);
		}
	}

    public LazyDataModel<HomeOrgGroupEntity> getGroupEntityList() {
   		return list;
    }

}

bwreg-webapp/src/main/java/edu/kit/scc/webreg/bean/admin/group/ListLocalGroupBean.java
/*******************************************************************************
 * Copyright (c) 2014 Michael Simon.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the GNU Public License v3.0
 * which accompanies this distribution, and is available at
 * http://www.gnu.org/licenses/gpl.html
 * 
 * Contributors:
 *     Michael Simon - initial
 ******************************************************************************/
package edu.kit.scc.webreg.bean.admin.group;

import java.io.Serializable;

import jakarta.faces.event.ComponentSystemEvent;
import jakarta.faces.view.ViewScoped;
import jakarta.inject.Inject;
import jakarta.inject.Named;

import org.primefaces.model.LazyDataModel;

import edu.kit.scc.webreg.entity.LocalGroupEntity;
import edu.kit.scc.webreg.model.GenericLazyDataModelImpl;
import edu.kit.scc.webreg.service.LocalGroupService;

@Named
@ViewScoped
public class ListLocalGroupBean implements Serializable {

	private static final long serialVersionUID = 1L;

	private LazyDataModel<LocalGroupEntity> list;
    
    @Inject
    private LocalGroupService service;

	public void preRenderView(ComponentSystemEvent ev) {
		if (list == null) {
			list = new GenericLazyDataModelImpl<LocalGroupEntity, LocalGroupService>(service);
		}
	}

    public LazyDataModel<LocalGroupEntity> getGroupEntityList() {
   		return list;
    }

}

bwreg-webapp/src/main/java/edu/kit/scc/webreg/bean/admin/group/ShowLocalProjectGroupBean.java
/*******************************************************************************
 * Copyright (c) 2014 Michael Simon.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the GNU Public License v3.0
 * which accompanies this distribution, and is available at
 * http://www.gnu.org/licenses/gpl.html
 * 
 * Contributors:
 *     Michael Simon - initial
 ******************************************************************************/
package edu.kit.scc.webreg.bean.admin.group;

import java.io.Serializable;
import java.util.List;

import jakarta.faces.event.ComponentSystemEvent;
import jakarta.faces.view.ViewScoped;
import jakarta.inject.Inject;
import jakarta.inject.Named;

import edu.kit.scc.webreg.entity.ServiceGroupFlagEntity;
import edu.kit.scc.webreg.entity.project.LocalProjectGroupEntity;
import edu.kit.scc.webreg.entity.project.LocalProjectGroupEntity_;
import edu.kit.scc.webreg.service.GroupService;
import edu.kit.scc.webreg.service.ServiceGroupFlagService;

@Named
@ViewScoped
public class ShowLocalProjectGroupBean implements Serializable {

	private static final long serialVersionUID = 1L;

	@Inject
	private GroupService groupService;

	@Inject
	private ServiceGroupFlagService groupFlagService;

	private LocalProjectGroupEntity entity;

	private List<ServiceGroupFlagEntity> groupFlagList;

	private Long id;

	public void preRenderView(ComponentSystemEvent ev) {
	}

	public Long getId() {
		return id;
	}

	public void setId(Long id) {
		this.id = id;
	}

	public List<ServiceGroupFlagEntity> getGroupFlagList() {
		if (groupFlagList == null) {
			groupFlagList = groupFlagService.findByGroup(entity);
		}
		return groupFlagList;
	}

	public LocalProjectGroupEntity getEntity() {
		if (entity == null) {
			entity = (LocalProjectGroupEntity) groupService.findByIdWithAttrs(id, LocalProjectGroupEntity_.users);
		}
		return entity;
	}
}

bwreg-webapp/src/main/java/edu/kit/scc/webreg/bean/sadm/group/GroupEventsBean.java
/*******************************************************************************
 * Copyright (c) 2014 Michael Simon.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the GNU Public License v3.0
 * which accompanies this distribution, and is available at
 * http://www.gnu.org/licenses/gpl.html
 * 
 * Contributors:
 *     Michael Simon - initial
 ******************************************************************************/
package edu.kit.scc.webreg.bean.sadm.group;

import java.io.Serializable;
import java.util.List;

import jakarta.faces.event.ComponentSystemEvent;
import jakarta.faces.view.ViewScoped;
import jakarta.inject.Inject;
import jakarta.inject.Named;

import edu.kit.scc.webreg.entity.EventType;
import edu.kit.scc.webreg.entity.GroupEventEntity;
import edu.kit.scc.webreg.entity.JobClassEntity;
import edu.kit.scc.webreg.service.GroupEventService;
import edu.kit.scc.webreg.service.JobClassService;

@Named
@ViewScoped
public class GroupEventsBean implements Serializable {

	private static final long serialVersionUID = 1L;

	@Inject
	private GroupEventService eventService;

	@Inject
	private JobClassService jobClassService;
	
	private List<GroupEventEntity> eventList;
	
	private List<JobClassEntity> jobClassList;
	
	private JobClassEntity selectedJobClass;
	
	private EventType selectedEventType;
	
	private Boolean initialized = false;
	
	public void preRenderView(ComponentSystemEvent ev) {
		if (! initialized) {
			eventList = eventService.findAll();
			jobClassList = jobClassService.findAll();
		}
	}

	public void addEvent() {
		GroupEventEntity ev = eventService.createNew();
		ev.setJobClass(selectedJobClass);
		ev.setEventType(selectedEventType);
		eventService.save(ev);
		eventList = eventService.findAll();
		selectedJobClass = null;
	}
	
	public void removeEvent(GroupEventEntity ev) {
		selectedJobClass = ev.getJobClass();
		selectedEventType = ev.getEventType();
		eventService.delete(ev);
		eventList = eventService.findAll();
	}
	
	public EventType[] getUserEventTypes() {
		return EventType.values();
	}

	public List<JobClassEntity> getJobClassList() {
		return jobClassList;
	}

	public void setJobClassList(List<JobClassEntity> jobClassList) {
		this.jobClassList = jobClassList;
	}

	public JobClassEntity getSelectedJobClass() {
		return selectedJobClass;
	}

	public void setSelectedJobClass(JobClassEntity selectedJobClass) {
		this.selectedJobClass = selectedJobClass;
	}

	public List<GroupEventEntity> getEventList() {
		return eventList;
	}

	public void setEventList(List<GroupEventEntity> eventList) {
		this.eventList = eventList;
	}

	public EventType getSelectedEventType() {
		return selectedEventType;
	}

	public void setSelectedEventType(EventType selectedEventType) {
		this.selectedEventType = selectedEventType;
	}

}

bwreg-webapp/src/main/java/edu/kit/scc/webreg/rest/GroupController.java
package edu.kit.scc.webreg.rest;

import jakarta.inject.Inject;
import jakarta.servlet.http.HttpServletRequest;
import jakarta.ws.rs.GET;
import jakarta.ws.rs.Path;
import jakarta.ws.rs.PathParam;
import jakarta.ws.rs.Produces;
import jakarta.ws.rs.core.Context;
import jakarta.ws.rs.core.MediaType;

import edu.kit.scc.webreg.drools.exc.UnauthorizedException;
import edu.kit.scc.webreg.dto.entity.GroupEntityDto;
import edu.kit.scc.webreg.dto.service.GroupDtoService;
import edu.kit.scc.webreg.exc.RestInterfaceException;
import edu.kit.scc.webreg.sec.SecurityFilter;
import edu.kit.scc.webreg.util.StringIds;

@Path("/group-admin")
public class GroupController {

	@Inject
	private GroupDtoService groupDtoService;

	@Path(value = "/find/id/{id}")
	@Produces({ MediaType.APPLICATION_JSON })
	@GET
	public GroupEntityDto findById(@PathParam("id") Long id, @Context HttpServletRequest request)
			throws RestInterfaceException {
		return groupDtoService.findById(id, resolveUserId(request), false);
	}

	@Path(value = "/find/name/{name}")
	@Produces({ MediaType.APPLICATION_JSON })
	@GET
	public GroupEntityDto findByName(@PathParam("name") String name, @Context HttpServletRequest request)
			throws RestInterfaceException {
		return groupDtoService.findByName(name, resolveUserId(request), false);
	}

	@Path(value = "/find-detail/id/{id}")
	@Produces({ MediaType.APPLICATION_JSON })
	@GET
	public GroupEntityDto findDetailById(@PathParam("id") Long id, @Context HttpServletRequest request)
			throws RestInterfaceException {
		return groupDtoService.findById(id, resolveUserId(request), true);
	}

	@Path(value = "/find-detail/name/{name}")
	@Produces({ MediaType.APPLICATION_JSON })
	@GET
	public GroupEntityDto findDetailByName(@PathParam("name") String name, @Context HttpServletRequest request)
			throws RestInterfaceException {
		return groupDtoService.findByName(name, resolveUserId(request), true);
	}

	@Path(value = "/add/groupId/{groupId}/userId/{userId}")
	@Produces({ MediaType.APPLICATION_JSON })
	@GET
	public GroupEntityDto addUserToGroup(@PathParam("groupId") Long groupId, @PathParam("userId") Long userId,
			@Context HttpServletRequest request) throws RestInterfaceException {
		return groupDtoService.addUserToGroup(groupId, userId, resolveUserId(request));
	}

	@Path(value = "/remove/groupId/{groupId}/userId/{userId}")
	@Produces({ MediaType.APPLICATION_JSON })
	@GET
	public GroupEntityDto removeUserFromGroup(@PathParam("groupId") Long groupId, @PathParam("userId") Long userId,
			@Context HttpServletRequest request) throws RestInterfaceException {
		return groupDtoService.removeUserToGroup(groupId, userId, resolveUserId(request));
	}

	@Path(value = "/create/{ssn}/{name}")
	@Produces({ MediaType.APPLICATION_JSON })
	@GET
	public GroupEntityDto create(@PathParam("ssn") String ssn, @PathParam("name") String name,
			@Context HttpServletRequest request) throws RestInterfaceException {
		return groupDtoService.create(ssn, name, resolveUserId(request));
	}

	protected Long resolveUserId(HttpServletRequest request) throws UnauthorizedException {
		if (request.getAttribute(StringIds.IDENTITY_ID) != null
				&& request.getAttribute(StringIds.IDENTITY_ID) instanceof Long) {
			return (Long) request.getAttribute(StringIds.IDENTITY_ID);
		} else if (request.getAttribute(StringIds.ADMIN_USER_ID) != null
				&& request.getAttribute(StringIds.ADMIN_USER_ID) instanceof Long) {
			return (Long) request.getAttribute(StringIds.ADMIN_USER_ID);
		} else {
			throw new UnauthorizedException("No user is set");
		}
	}
}

bwreg-webapp/src/main/webapp/admin/group/group-events.xhtml
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
    "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml"
	xmlns:f="jakarta.faces.core"
	xmlns:h="jakarta.faces.html"
	xmlns:ui="jakarta.faces.facelets"
	xmlns:bw="http://www.scc.kit.edu/bwfacelets"
	xmlns:p="http://primefaces.org/ui">
<head>
<title></title>
</head>
<body>
<f:view>
	<f:metadata>
		<f:event type="jakarta.faces.event.PreRenderViewEvent"
            listener="#{groupEventsBean.preRenderView}" />
	</f:metadata>

<ui:composition template="/template/default-admin.xhtml">
	<ui:param name="title" value="#{messages.title}"/>

	<ui:define name="content">
	<h:form id="form">
		<h2><h:outputText value="#{messages.user_events}"/></h2>
	
		<div class="panel">
			<p:panel header="#{messages.user_events}">
 				<p:dataTable id="eventTable" var="ev" value="#{groupEventsBean.eventList}">
 					<p:column>
						<f:facet name="header">
					 		<h:outputText value="#{messages.job_class}" />
						</f:facet>
				        <p:outputLabel value="#{ev.jobClass.name}"/>
 					</p:column>
 					<p:column>
						<f:facet name="header">
							<h:outputText value="#{messages.event_type}" />
						</f:facet>
				        <p:outputLabel value="#{ev.eventType}"/>
 					</p:column>
 					<p:column>
						<f:facet name="header">
							<h:outputText value="#{messages.action}" />
						</f:facet>
						<h:commandLink value="#{messages.remove}" action="#{groupEventsBean.removeEvent(ev)}">
							<f:ajax render=":form:newPropTable :form:eventTable" />
						</h:commandLink>
 					</p:column>
				</p:dataTable>

				<h:panelGrid id="newPropTable" columns="3" columnClasses="labelColumn, elementColumn">

			        <p:selectOneMenu value="#{groupEventsBean.selectedJobClass}"
			        	converter="#{jobClassConverter}">
			        	<f:selectItem itemLabel="Keine Job Klasse" itemValue="#{null}"/>
		            	<f:selectItems value="#{groupEventsBean.jobClassList}" 
		            		var="jc" itemLabel="#{jc.name} (id #{jc.id})" itemValue="#{jc}"/>
		            </p:selectOneMenu>

			        <p:selectOneMenu value="#{groupEventsBean.selectedEventType}">
		            	<f:selectItems value="#{groupEventsBean.userEventTypes}" 
		            		var="et" itemLabel="#{et}" itemValue="#{et}"/>
		            </p:selectOneMenu>
		            
					<h:commandLink value="#{messages.add}" action="#{groupEventsBean.addEvent()}">
						<f:ajax execute=":form:newPropTable" render=":form:newPropTable :form:eventTable" />
					</h:commandLink>
				</h:panelGrid>
				
			</p:panel>
		</div>
	</h:form>

	</ui:define>
</ui:composition>
</f:view>		
</body>
</html>

bwreg-webapp/src/main/webapp/admin/group/list-groups.xhtml
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
    "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml"
	xmlns:f="jakarta.faces.core"
	xmlns:h="jakarta.faces.html"
	xmlns:ui="jakarta.faces.facelets"
	xmlns:bw="http://www.scc.kit.edu/bwfacelets"
	xmlns:p="http://primefaces.org/ui"
	xmlns:of="http://omnifaces.org/functions">
<head>
<title></title>
</head>
<body>
<f:view>

	<f:metadata>
		<f:event type="jakarta.faces.event.PreRenderViewEvent"
            listener="#{listGroupBean.preRenderView}" />
	</f:metadata>

<ui:composition template="/template/default-admin.xhtml">
	<ui:param name="title" value="#{messages.title}"/>

	<ui:define name="content">
	
	<h:form id="form">
	
		<p:dataTable id="dataTable" var="group" value="#{listGroupBean.groupEntityList}" paginator="true"
					lazy="true" rows="15">
			<p:column sortBy="#{group.id}">
				<f:facet name="header">
					<h:outputText value="#{messages.id}" />
				</f:facet>
				<h:outputText value="#{group.id}" />
			</p:column>
			<p:column sortBy="#{group.prefix}" filterBy="#{group.prefix}" filterMatchMode="contains">
				<f:facet name="header">
					<h:outputText value="#{messages.prefix}" />
				</f:facet>
				<h:outputText value="#{group.prefix}" rendered="#{group.class.simpleName == 'HomeOrgGroupEntity'}" />
			</p:column>			
			<p:column sortBy="#{group.name}" filterBy="#{group.name}" filterMatchMode="contains">
				<f:facet name="header">
					<h:outputText value="#{messages.name}" />
				</f:facet>
				<h:link outcome="show-homeorg-group.xhtml" value="#{group.name}" rendered="#{group.class.simpleName == 'HomeOrgGroupEntity'}" >
      				<f:param name="id" value="#{group.id}"/>
    			</h:link>
				<h:link outcome="show-local-group.xhtml" value="#{group.name}" rendered="#{group.class.simpleName == 'LocalGroupEntity'}" >
      				<f:param name="id" value="#{group.id}"/>
    			</h:link>
				<h:link outcome="show-as-group.xhtml" value="#{group.name}" rendered="#{group.class.simpleName == 'AttributeSourceGroupEntity'}" >
      				<f:param name="id" value="#{group.id}"/>
    			</h:link>
				<h:link outcome="show-local-project-group.xhtml" value="#{group.name}" rendered="#{group.class.simpleName == 'LocalProjectGroupEntity'}" >
      				<f:param name="id" value="#{group.id}"/>
    			</h:link>
			</p:column>			
			<p:column sortBy="#{group.gidNumber}">
				<f:facet name="header">
					<h:outputText value="#{messages.gid_number}" />
				</f:facet>
				<h:outputText value="#{group.gidNumber}" />
			</p:column>
			<p:column>
				<f:facet name="header">
					<h:outputText value="#{messages.class}" />
				</f:facet>
				<h:outputText value="#{group.class.simpleName}" />
			</p:column>
			<p:column>
				<f:facet name="header">
					<h:outputText value="#{messages.properties}" />
				</f:facet>
				<h:outputText value="#{group.idp.entityId}" rendered="#{group.class.simpleName == 'HomeOrgGroupEntity'}" />
			</p:column>
		</p:dataTable>
	
		<p:panel>
		
			<h:panelGrid columns="3">
				<p:outputLabel for="@next" value="Generate group flags for service: "/>
				<p:selectOneMenu value="#{listGroupBean.pickedService}" converter="#{serviceConverter}" >
					<f:selectItems var="service" value="#{listGroupBean.serviceList}" itemValue="#{service}" itemLabel="#{service.name}"/>
				</p:selectOneMenu>
		        <p:commandButton id="addFlags" action="#{listGroupBean.addAllGroupFlags()}" value="#{messages.add_all_group_flags}"
			        	ajax="false"/>
			        	
				<p:outputLabel for="@next" value="Size per message: "/>
				<p:inputNumber value="#{listGroupBean.sizePerMessage}" />
		        <p:commandButton id="addGF" action="#{listGroupBean.fireDirtyGroupChangeEvent()}" value="#{messages.fire_group_change_event}"
				        	ajax="false"/>					
			</h:panelGrid>					

		</p:panel>
	</h:form>

	</ui:define>
</ui:composition>		
</f:view>
</body>
</html>